package com.flutter.linkshare

import android.annotation.SuppressLint
import android.app.PendingIntent.getActivity
import android.content.Context
import android.content.Intent
import android.content.Intent.getIntent
import android.util.Log
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** LinksharePlugin */
class LinksharePlugin: FlutterPlugin, ActivityAware {
  private val tag: String = "LinksharePlugin"
  private var methodCallHandler: MethodCallHandlerImpl? = null
  private var linkshare: Linkshare? = null

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    linkshare = Linkshare(flutterPluginBinding.applicationContext, /*activity=*/ null)
    methodCallHandler = MethodCallHandlerImpl(linkshare!!, /*channel*/null)
    methodCallHandler!!.startListening(flutterPluginBinding.binaryMessenger)
  }

  @SuppressLint("NewApi")
  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    if (methodCallHandler ==  null) {
      Log.wtf(tag, "Already detached from the engine.");
      return;
    }

    methodCallHandler!!.stopListening();
    methodCallHandler = null;
    linkshare = null;
  }

  @SuppressLint("NewApi")
  override fun onAttachedToActivity(@NonNull activityPluginBinding: ActivityPluginBinding){
    if (methodCallHandler == null) {
      Log.wtf(tag, "linkshare was never set.")
      return
    }

    linkshare!!.activity = activityPluginBinding.activity
  }

  @SuppressLint("NewApi")
  override fun onDetachedFromActivity() {
    if (methodCallHandler == null) {
      Log.wtf(tag, "urlLauncher was never set.");
      return;
    }
    linkshare!!.activity = null
  }

  override fun onDetachedFromActivityForConfigChanges() {
    onDetachedFromActivity()
  }

  override fun onReattachedToActivityForConfigChanges(@NonNull activityPluginBinding: ActivityPluginBinding) {
    onAttachedToActivity(activityPluginBinding);
  }
}
