package com.flutter.linkshare

import android.annotation.SuppressLint
import android.util.Log
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

final class MethodCallHandlerImpl(private var linkshare: Linkshare?, private var channel: MethodChannel?) : MethodChannel.MethodCallHandler {

    private val tag = "MethodCallHandlerImpl"

    @SuppressLint("NewApi")
    fun startListening(messenger: BinaryMessenger) {
        if (channel != null) {
            Log.wtf(tag, "Setting method call handler before the last was disposed.")
            stopListening()
        }

        channel = MethodChannel(messenger, "plugins.flutter.io/linkshare")
        channel!!.setMethodCallHandler(this)
    }

    @SuppressLint("NewApi")
    fun stopListening() {
        if (channel == null) {
            Log.wtf(tag, "Setting method call handler before the last was disposed.")
            return
        }

        channel!!.setMethodCallHandler(null)
        channel = null
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        val link: String? = call.argument("getLink");
        if (call.method == "getLink") onShare(call, result) else result.notImplemented()
    }

    private fun onShare(call: MethodCall, result: MethodChannel.Result) {
        result.success(linkshare!!.getLink())
    }

}